# 1) Introduction

The "Timeline {dygraphs}" plugin allows you to display **continuous data** in the form of a **timeline**,
such as **vital signs** or **laboratory data**.

<div style="text-align: center;">
    <img 
        src="https://framagit.org/interhop/linkr/LinkR-content/-/raw/main/img/plugins/timeline_dygraphs/figure.png"
        alt="Dygraphs timeline"
        style="width: 100%; max-width: 750px;"
    />
</div>

# 2) Features

## Figure settings

<div style="text-align: center;">
    <img 
        src="https://framagit.org/interhop/linkr/LinkR-content/-/raw/main/img/plugins/timeline_dygraphs/en_figure_settings.png"
        alt="Figure settings"
        style="width: 100%; max-width: 250px; border: solid 1px #ccc; padding: 5px;"
    />
</div>

Here are the parameters you can adjust:

- **Data to display**: choose whether you want to display patient data or visit data

- **Concepts**: which concepts do you want to see on the figure?
This list includes the concepts you selected when creating the widget.

- **Synchronize timelines**: several plugins work with a timeline
(the scroll bar below the timeline where you can choose the period to display).
This feature allows you to synchronize the timelines of several widgets on the same tab.

## Code

<div style="text-align: center;">
    <img 
        src="https://framagit.org/interhop/linkr/LinkR-content/-/raw/main/img/plugins/timeline_dygraphs/figure_and_code.png"
        alt="Figure and code"
        style="width: 100%; max-width: 750px; border: solid 1px #ccc; padding: 5px;"
    />
</div>

As with **all plugins** on LinkR, the **low-code** interface allows you to generate code from the graphical interface.

To do this, go to the "Figure settings" tab, and once you have chosen your parameters, click on "Display figure".

This will:

- **generate the code** corresponding to the chosen parameters
- then **execute the code** and display the figure corresponding to the code

You can then **modify the code** directly and save it.

If you click on "Run code" from the tab with the code editor, it will display the figure corresponding to the code.

However, if you are on the tab corresponding to the figure settings, it will erase the current code and replace it
with the code corresponding to the current parameters.

## Save files

<div style="text-align: center;">
    <img 
        src="https://framagit.org/interhop/linkr/LinkR-content/-/raw/main/img/plugins/timeline_dygraphs/en_settings_files.png"
        alt="Settings files"
        style="width: 100%; max-width: 280px; border: solid 1px #ccc; padding: 5px;"
    />
</div>

You can **save** the figure parameters and code from the save files management page.

To do this, click on the name of the selected file at the top of the widget ("Save File 1" in the screenshot above).
You can then **add** or **delete** save files.

Then return to the "Figure settings" or "Code" tabs and save your parameters and code.

## General settings

<div style="text-align: center;">
    <img 
        src="https://framagit.org/interhop/linkr/LinkR-content/-/raw/main/img/plugins/timeline_dygraphs/en_general_settings.png"
        alt="General settings"
        style="width: 100%; max-width: 280px; border: solid 1px #ccc; padding: 5px;"
    />
</div>

The general settings are divided into:

- **Display Settings**

    - **Show save file**: show or hide the name of the selected save file
    - **Figure and settings/editor side by side**: do you want the figure to appear side by side
    with the figure settings or the figure code? This avoids going back and forth between
    the different tabs during the widget configuration phase.

- **Code Execution**

    - **Run code when loading a save file**: this allows the code to be executed when
    the selected save file changes, which is useful when loading a project:
    this allows all widgets with this option to be loaded
    - **Run code when data is updated**: for this widget, this means that
    the data is updated when you change patient or visit, depending on the value of the 
    "Data to display" parameter
